-------------------------------------------------------------------------------
--                L  O  C  A  L     V  A  R  I  A  B  L  E  S
-------------------------------------------------------------------------------

local addonName, L = ...;

local raceInfo =
{
  [0] = -- Totals
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {0,  0},
    keystoneId     = 0,
    keystoneSize   = 0,
    fragmentId     = 0,
  },
  [1] = -- Dwarf
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {4, 27},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 384,
  },
  [2] = -- Draenei
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  8},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 398,
  },
  [3] = -- Fossil
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {5, 12},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 393,
  },
  [4] = -- Night Elf
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {7, 18},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 394,
  },
  [5] = -- Nerubian
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  7},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 400,
  },
  [6] = -- Orc
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {1,  9},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 397,
  },
  [7] = -- Tol'vir
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {6,  7},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 401,
  },
  [8] = -- Troll
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {3, 14},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 385,
  },
  [9] = -- Vrykul
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 399,
  },
  [10] = -- Mantid
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  8},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 754,
  },
  [11] = -- Pandaren
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 676,
  },
  [12] = -- Mogu
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 752,
  },
  [13] = -- Arakkoa
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 829,
  },
  [14] = -- Draenor Clans
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {1, 20},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 821,
  },
  [15] = -- Ogre
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 828,
  },
};

local lootIds = {};

-- Mapping of spell ID to item ID(s) for all archaeology projects
local artifactInfo =
{
  {86857, 1, 63408},
  {86864, 1, 63409},
  {86865, 1, 63110},
  {86866, 1, 63112},
  {88180, 1, 63410},
  {88181, 1, 63411},
  {88262, 8, 63115},
  {88907, 8, 63120},
  {88908, 8, 63118},
  {88909, 1, 63111},
  {88910, 1, 63113},
  {88929, 3, 63109},
  {88930, 3, 63121},
  {89009, 4, 63129},
  {89012, 4, 63130},
  {89014, 4, 63131},
  {89693, 3, 60955},
  {89696, 4, 63407},
  {89701, 8, 63412},
  {89711, 8, 63413},
  {89717, 1, 63414},
  {89890, 8, 63523},
  {89891, 8, 63524},
  {89893, 4, 63525},
  {89894, 4, 63526},
  {89895, 3, 63527},
  {89896, 4, 63528},
  {90410, 1, 64337},
  {90411, 1, 64339},
  {90412, 1, 64340},
  {90413, 1, 64342},
  {90415, 1, 64343},
  {90419, 1, 64344},
  {90420, 8, 64345},
  {90421, 8, 64346},
  {90423, 8, 64347},
  {90429, 8, 64348},
  {90432, 3, 64349},
  {90433, 3, 64350},
  {90451, 4, 64354},
  {90452, 3, 64355},
  {90453, 4, 64356},
  {90458, 4, 64357},
  {90464, 4, 64358},
  {90493, 4, 64361},
  {90504, 1, 64362},
  {90506, 1, 64366},
  {90509, 1, 64367},
  {90518, 1, 64368},
  {90519, 1, 64371},
  {90521, 1, 64372},
  {90553, 1, 64373},
  {90558, 8, 64374},
  {90581, 8, 64375},
  {90608, 8, 64377},
  {90609, 4, 64378},
  {90610, 4, 64379},
  {90611, 4, 64381},
  {90612, 4, 64382},
  {90614, 4, 64383},
  {90616, 4, 64643},
  {90617, 3, 64385},
  {90618, 3, 64387},
  {90619, 3, 60954},
  {90622, 6, 64389},
  {90720, 6, 64417},
  {90728, 6, 64418},
  {90730, 6, 64419},
  {90732, 6, 64420},
  {90734, 6, 64421},
  {90831, 6, 64436},
  {90832, 6, 64437},
  {90833, 6, 64438},
  {90843, 6, 64644},
  {90853, 2, 64440},
  {90860, 2, 64442},
  {90861, 2, 64443},
  {90864, 2, 64444},
  {90968, 2, 64453},
  {90974, 2, 64454},
  {90975, 2, 64455},
  {90983, 2, 64456},
  {90984, 2, 64457},
  {90987, 2, 64458},
  {90988, 9, 64459},
  {90997, 9, 64460},
  {91008, 9, 64461},
  {91012, 9, 64462},
  {91014, 9, 64464},
  {91084, 9, 64467},
  {91089, 3, 64468},
  {91132, 3, 64473},
  {91133, 5, 64474},
  {91170, 5, 64475},
  {91188, 5, 64476},
  {91191, 5, 64477},
  {91197, 5, 64478},
  {91209, 5, 64479},
  {91211, 5, 64480},
  {91214, 5, 64481},
  {91215, 5, 64482},
  {91219, 1, 64483},
  {91221, 1, 64484},
  {91223, 1, 64485},
  {91224, 1, 64486},
  {91225, 1, 64487},
  {91226, 1, 64488},
  {91227, 1, 64489},
  {91757, 4, 64645},
  {91761, 4, 64646},
  {91762, 4, 64647},
  {91766, 4, 64648},
  {91769, 4, 64650},
  {91773, 4, 64651},
  {91775, 7, 64652},
  {91779, 7, 64653},
  {91780, 7, 64654},
  {91782, 7, 64655},
  {91785, 7, 64656},
  {91790, 7, 64657},
  {91792, 7, 64658},
  {91793, 1, 64659},
  {92137, 7, 60846},
  {92139, 7, 64880},
  {92145, 7, 64881},
  {92148, 7, 64883},
  {92163, 7, 64885},
  {92168, 7, 64904},
  {93440, 1, 66054},
  {93441, 4, 66055},
  {93442, 3, 66056},
  {93443, 3, 66057},
  {93444, 8, 66058},
  {98533, 3, 69764},
  {98556, 8, 69777},
  {98560, 3, 69776},
  {98569, 9, 69775},
  {98582, 3, 69821},
  {98588, 8, 69824},
  {113968, 11, {79896, 85557}},
  {113971, 11, {79897, 85558}},
  {113972, 11, {79898, 89178}},
  {113973, 11, {79899, 89179}},
  {113974, 11, {79900, 89180}},
  {113975, 11, {79901, 89181}},
  {113976, 11, {79902, 89182}},
  {113977, 11, {79903, 89183}},
  {113978, 11, {79904, 89184}},
  {113979, 11, {79905, 89185}},
  {113980, 11, 89684},
  {113981, 11, 89685},
  {113982, 12, {79908, 89169}},
  {113983, 12, {79909, 89170}},
  {113984, 12, {79910, 89171}},
  {113985, 12, {79911, 89172}},
  {113986, 12, {79912, 89173}},
  {113987, 12, {79913, 89174}},
  {113988, 12, {79914, 89175}},
  {113989, 12, {79915, 89176}},
  {113990, 12, {79916, 85477}},
  {113991, 12, {79917, 89209}},
  {113992, 12, 89611},
  {113993, 12, 89614},
  {139776, 10, {95375, 95383}},
  {139779, 10, {95376, 95384}},
  {139780, 10, {95377, 95385}},
  {139781, 10, {95378, 95386}},
  {139782, 10, {95379, 95387}},
  {139783, 10, {95380, 95388}},
  {139784, 10, {95381, 95389}},
  {139785, 10, {95382, 95390}},
  {139786, 10, 95391},
  {139787, 10, 95392},
  {168290, 14, {114141, 114142}},
  {168291, 14, {114143, 114144}},
  {168292, 14, {114145, 114146}},
  {168293, 14, {114147, 114148}},
  {168294, 14, {114149, 114150}},
  {168295, 14, {114151, 114152}},
  {168296, 14, {114153, 114154}},
  {168297, 14, {114155, 114156}},
  {168298, 14, {114157, 114158}},
  {168299, 14, {114159, 114160}},
  {168300, 14, {114161, 114162}},
  {168301, 14, {114163, 114164}},
  {168302, 14, {114165, 114166}},
  {168303, 14, {114167, 114168}},
  {168304, 14, {114169, 114170}},
  {168305, 14, {114171, 114172}},
  {168306, 14, {114173, 114174}},
  {168307, 14, {114175, 114176}},
  {168308, 14, {114177, 114178}},
  {168309, 15, {114181, 114182}},
  {168310, 15, {114183, 114184}},
  {168311, 15, {114185, 114186}},
  {168312, 15, {114187, 114188}},
  {168313, 15, {114189, 114208}},
  {168314, 15, {114190, 114209}},
  {168315, 15, {114191, 114210}},
  {168316, 15, {114192, 114211}},
  {168317, 15, {114193, 114212}},
  {168318, 15, {114194, 114213}},
  {168319, 15, 117385},
  {168320, 15, 117384},
  {168321, 13, {114197, 114215}},
  {168322, 13, {114198, 114216}},
  {168323, 13, {114199, 114217}},
  {168324, 13, {114200, 114218}},
  {168325, 13, {114201, 114219}},
  {168326, 13, {114202, 114220}},
  {168327, 13, {114203, 114221}},
  {168328, 13, {114204, 114222}},
  {168329, 13, {114205, 114223}},
  {168330, 13, {114206, 114224}},
  {168331, 13, 117382},
  {172459, 14, 116985},
  {172460, 13, 117354},
  {172466, 14, 117380},
};

local selectedRaceIdx = 0;

-------------------------------------------------------------------------------
--                L  O  C  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to generate a checksum for an artifact's name. It uses the
-- 'Fletcher16' algorithm and has been verified to generate unique checksums
-- for all artifact names as of 2013-07-01 for English, French, German,
-- Portuguese and Spanish.
--
local function getArtifactNameChecksum(name, raceIdx)
  -- Local Variables
  local nameLeft = string.len(name);
  local nameIdx = 1;
  local sum1 = 0xFF;
  local sum2 = 0xFF;

  -- Process the name in 20-byte chunks
  while (nameLeft > 0) do
    for blockIdx = nameIdx, math.min(nameIdx+19, nameLeft) do
      sum1 = sum1+string.byte(name, blockIdx);
      sum2 = sum2+sum1;
    end
    sum1     = bit.band(sum1, 0xFF)+bit.rshift(sum1, 8);
    sum2     = bit.band(sum2, 0xFF)+bit.rshift(sum2, 8);
    nameIdx  = nameIdx+20;
    nameLeft = nameLeft-20;
  end
  sum1 = bit.band(sum1, 0xFF)+bit.rshift(sum1, 8);
  sum2 = bit.band(sum2, 0xFF)+bit.rshift(sum2, 8);

  return bit.lshift(raceIdx, 16)+bit.lshift(sum2, 8)+sum1;
end

-------------------------------------------------------------------------------
--               G  L  O  B  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to add info about how many artifacts have been completed
--
function NigglesArchaeologyCompletedUpdate()
  -- Local Variables
  local frame = ArchaeologyFrameCompletedPage;
  local text;
  local artifactIdx = 0;
  local raceIdx = frame.raceFilter;

  -- Update the titles with the completed progress
  for _, title in ipairs({frame.titleTop, frame.titleMid}) do
    -- Check if the top title is displayed
    if (title:IsShown()) then
      -- Get the current text
      text = title:GetText();
      if ((text ~= nil) and (text ~= "")) then
        -- Work out the rarity for the title
        if (text:find(ARCHAEOLOGY_RARE_COMPLETED, 1, true)) then
          artifactIdx = 1;
          text        = ARCHAEOLOGY_RARE_COMPLETED;
        elseif (text:find(ARCHAEOLOGY_COMMON_COMPLETED, 1, true)) then
          artifactIdx = 2;
          text        = ARCHAEOLOGY_COMMON_COMPLETED;
        else
          artifactIdx = 0;
        end

        -- Update the title's text
        if (artifactIdx > 0) then
          if ((NigglesDBC.settings.ProfArchProgress == true) and
              (raceInfo[raceIdx].totalArtifacts[artifactIdx] > 0)) then
            text = text.."|n"..raceInfo[raceIdx].numArtifacts[artifactIdx]..
              "/"..raceInfo[raceIdx].totalArtifacts[artifactIdx];
          end
          title:SetText(text);
        end
      end
    end
  end

  return;
end

--
-- Function to find the spell ID for the specified artifact
--
function NigglesArchaeologyGetSpellId()
  -- Local Variables
  local artifactName = GetSelectedArtifactInfo();
  local checksum;
  local spellId = 0;

  -- Check the name of the selected artifact could be obtained
  if (artifactName ~= nil) then
    -- Get a checksum for the artifact's name
    checksum = getArtifactNameChecksum(artifactName, selectedRaceIdx);

    -- Search for the artifact's info
    for _, currentItem in ipairs(artifactInfo) do
      if (checksum == currentItem[4]) then
        spellId = currentItem[1];
        break;
      end
    end
  end

  return spellId;
end

--
-- Function to initialise the Niggles Archaeology functionality
--
function NigglesArchaeologyInitialise()
  -- Local Variables
  local itemId;
  local artifactName;
  local numRaces = #raceInfo;

  -- Get info about the races
  for idx = 1, numRaces do
    -- Get ID of the race's keystone
    _, _, raceInfo[idx].keystoneId = GetArchaeologyRaceInfo(idx);

    -- Add the race's keystone and fragment IDs to the loot IDs
    if (raceInfo[idx].keystoneId > 0) then
      lootIds[raceInfo[idx].keystoneId] = true;
    end
    if (raceInfo[idx].fragmentId > 0) then
      lootIds[-raceInfo[idx].fragmentId] = true;
    end

    -- Update the total number of artifacts
    raceInfo[0].totalArtifacts[1] =
      raceInfo[0].totalArtifacts[1]+raceInfo[idx].totalArtifacts[1];
    raceInfo[0].totalArtifacts[2] =
      raceInfo[0].totalArtifacts[2]+raceInfo[idx].totalArtifacts[2];
  end

  -- Get checksums for the names of the artifact spells
  for _, currentItem in ipairs(artifactInfo) do
    artifactName   = GetSpellInfo(currentItem[1]);
    currentItem[4] = getArtifactNameChecksum(artifactName, currentItem[2]);
  end

  return;
end

--
-- Function to check if an item is an archaeology keystone
--
function NigglesArchaeologyIsLoot(itemType, itemLink)
  -- Local Variables
  local itemId = 0;

  -- Extract the item ID from the specified item link
  if (itemType == LOOT_SLOT_CURRENCY) then
    itemId = -tonumber(string.match(itemLink, "|Hcurrency:(%d+)|h"));
  elseif (itemType == LOOT_SLOT_ITEM) then
    itemId = tonumber(string.match(itemLink, "|Hitem:(%d+):"));
  end
    
  -- Check if the item ID is for an archaeology keystone or fragment
  return (lootIds[itemId] ~= nil);
end

--
-- Function to process events
--
function NigglesArchaeologyOnEvent(self, event, ...)
  -- Process the event
  if ((event == "ARTIFACT_UPDATE") or
      (event == "ARTIFACT_COMPLETE")) then
    RequestArtifactCompletionHistory();
  elseif (event == "ARTIFACT_HISTORY_READY") then
    NigglesArchaeologyUpdateTotals();
  end

  return;
end

--
-- Function called when Blizzard's Archaeology addon is loaded
--
function NigglesArchaeologyOnLoad()
  -- Local Variables
  local frame;

  -- Add hooks to the functions used to update the pages
  hooksecurefunc("ArchaeologyFrame_UpdateSummary",
    NigglesArchaeologySummaryUpdate);
  ArchaeologyFrame.summaryPage.UpdateFrame = ArchaeologyFrame_UpdateSummary;
  hooksecurefunc("ArchaeologyFrame_UpdateComplete",
    NigglesArchaeologyCompletedUpdate);
  ArchaeologyFrame.completedPage.UpdateFrame = ArchaeologyFrame_UpdateComplete;

  -- Hook functions into the 'Prev' and 'Next' buttons on the 'Completed' page
  ArchaeologyFrameCompletedPagePrevPageButton:HookScript("OnMouseUp",
    NigglesFirstLastPage);
  ArchaeologyFrameCompletedPageNextPageButton:HookScript("OnMouseUp",
    NigglesFirstLastPage);

  -- Enable right clicking on the artifact page to go back to the summary page
  ArchaeologyFrameArtifactPage:EnableMouse(true);
  ArchaeologyFrameArtifactPage:HookScript("OnMouseUp",
    function(self, button)
      -- Check the option is enabled and the right button was clicked
      if ((NigglesDBC.settings.ProfArchRClickBack == true) and
          (button == "RightButton")) then
        -- Click the 'Summary' button
        ArchaeologyFrame_OnTabClick(ArchaeologyFrameSummarytButton);
      end
    end);

  -- Create the frame used to provide a tooltip for the current artifact
  -- NOTE: This is done here, rather than in the XML file, because the
  --       Archaeology panel is implemented as an on-demand addon.
  frame = CreateFrame("Frame", "NigglesArtifactIcon",
    ArchaeologyFrameArtifactPage, "NigglesArtifactIconTemplate");
  frame:SetShown(NigglesDBC.settings.ProfArchEnhIcon);

  -- Register the frame for some events
  frame:RegisterEvent("ARTIFACT_UPDATE");
  frame:RegisterEvent("ARTIFACT_COMPLETE");
  frame:RegisterEvent("ARTIFACT_HISTORY_READY");
  frame:HookScript("OnEvent", NigglesArchaeologyOnEvent);

  -- Request artifact completion history from the server
  RequestArtifactCompletionHistory();

  -- Adjust the position of the races slightly on the Summary page
  ArchaeologyFrameSummaryPageRace1:SetPoint("TOPLEFT", 60, -75);

  return;
end

--
-- Function called when a race is selected for Archaeology
--
function NigglesArchaeologyOnSelect(raceIdx)
  -- Save the selected race
  selectedRaceIdx = raceIdx;

  return;
end

--
-- Function to update the progress of each race's artifact
--
function NigglesArchaeologySummaryUpdate(self)
  -- Local Variables
  local bagIdx;
  local button;
  local itemCount;
  local itemId;
  local numFragments;
  local numRequired;
  local numRaces = GetNumArchaeologyRaces();
  local numSlots;
  local numSockets;
  local raceKeystones = {};
  local raceIdx;
  local raceName;

  -- Check if the archaeology panels should be enhanced
  if ((NigglesDBC.settings.ProfArchHilite == true) or
      (NigglesDBC.settings.ProfArchKeystones == true)) then
    -- Get the number of race keystones in the character's bags, if required
    if (NigglesDBC.settings.ProfArchKeystones) then
      for raceIdx = 1, numRaces do
        raceKeystones[raceIdx] = GetItemCount(raceInfo[raceIdx].keystoneId,
          false);
      end
    end

    -- Update the progress of each race's artifact
    for idx = 1, ARCHAEOLOGY_MAX_RACES do
      raceIdx = idx+(ARCHAEOLOGY_MAX_RACES*(self.currentPage-1));
      button  = self["race"..idx];
      if ((button ~= nil) and (raceIdx <= numRaces)) then
        -- Check if the player has started any artifacts for the race
        if (GetNumArtifactsByRace(raceIdx) > 0) then
          -- Get the number of fragments currently possessed and required
          raceName, _, _, numFragments, numRequired =
            GetArchaeologyRaceInfo(raceIdx);

          -- Update the number of fragments, if required
          if (NigglesDBC.settings.ProfArchKeystones == true) then
            -- Get the number of sockets the current artifact has
            SetSelectedArtifact(raceIdx);
            _, _, _, _, _, numSockets =  GetSelectedArtifactInfo();

            -- Update the number of fragments
            numFragments = numFragments+
              (math.min(numSockets, (raceKeystones[raceIdx] or 0))*
                raceInfo[raceIdx].keystoneSize);
          end

          -- Update the progress
          if ((NigglesDBC.settings.ProfArchHilite == true) and
              (numFragments >= numRequired)) then
            button.raceName:SetText(raceName.."|n"..
              NORMAL_FONT_COLOR_CODE..
              numFragments.."/"..numRequired..
              FONT_COLOR_CODE_CLOSE);
          else
            button.raceName:SetText(raceName.."|n"..
              numFragments.."/"..numRequired);
          end
        end
      end
    end
  end

  return;
end

--
-- Function to process a click on the tooltip for an artifact
--
function NigglesArchaeologyTooltipOnClick(frame)
  -- Local Variables
  local artifactChecksum;
  local artifactName;
  local artifact = nil;
  local hyperlink;

  -- Get the name of the selected artifact & its checksum
  artifactName     = GetSelectedArtifactInfo();
  artifactChecksum = getArtifactNameChecksum(artifactName, selectedRaceIdx);

  -- Search for the artifact's info
  for idx, currentItem in ipairs(artifactInfo) do
    if (artifactChecksum == currentItem[4]) then
      artifact = currentItem;
      break;
    end
  end

  -- Check the artifact was found
  if (artifact ~= nil) then
    for _, itemId in
      ipairs(type(artifact[3]) == "table" and artifact[3] or {artifact[3]}) do
      -- Get the artifact's hyperlink
      _, hyperlink = GetItemInfo(itemId)
      if (hyperlink ~= nil) then
        -- Call the standard handler
        HandleModifiedItemClick(hyperlink);
      end
    end
  end

  return;
end

--
-- Function to display the tooltip for an artifact
--
function NigglesArchaeologyTooltipOnEnter(frame)
  -- Local Variables
  local artifactChecksum = 0;
  local artifactName;
  local artifact = nil;
  local itemId;
  local prevTooltip = nil;
  local tooltip;

  -- Get the name of the selected artifact & its checksum
  artifactName     = GetSelectedArtifactInfo();
  artifactChecksum = getArtifactNameChecksum(artifactName, selectedRaceIdx);

  -- Search for the artifact's info
  for idx, currentItem in ipairs(artifactInfo) do
    if (artifactChecksum == currentItem[4]) then
      artifact = currentItem;
      break;
    end
  end

  -- Check the artifact was found
  if (artifact ~= nil) then
    -- Work out the ID of the item to display in the GameTooltip
    if (type(artifact[3]) == "table") then
      itemId = artifact[3][1];
    else
      itemId = artifact[3];
    end

    -- Set the first tooltip to the Game tooltip
    _G["NigglesTooltip1"] = GameTooltip;

    -- Display tooltips for all the artifact's items
    for idx, itemId in
      ipairs(type(artifact[3]) == "table" and artifact[3] or {artifact[3]}) do
      -- Make sure the tooltip exists
      if (_G["NigglesTooltip"..idx] == nil) then
        tooltip = CreateFrame("GameTooltip", "NigglesTooltip"..idx, nil,
          "GameTooltipTemplate");
      else
        tooltip = _G["NigglesTooltip"..idx];
      end

      -- Position the tooltip
      if (prevTooltip == nil) then
        tooltip:SetOwner(frame, "ANCHOR_BOTTOMRIGHT", 0);
      else
        tooltip:SetOwner(prevTooltip, "ANCHOR_NONE", 0);
        tooltip:ClearAllPoints();
        tooltip:SetPoint("TOPLEFT", prevTooltip, "TOPRIGHT", 0, 0);
      end
      prevTooltip = tooltip;

      -- Set the tooltip's hyperlink and show it
      tooltip:SetHyperlink("item:"..itemId..":0:0:0:0:0:0:0");
      tooltip:Show();
    end
  end

  return;
end

--
-- Function to hide the tooltip(s) for an artifact
--
function NigglesArchaeologyTooltipOnLeave(frame)
  -- Local Variables
  local idx = 1;

  -- Hide all the Niggles tooltips
  while (_G["NigglesTooltip"..idx] ~= nil) do
    _G["NigglesTooltip"..idx]:Hide();
    idx = idx+1;
  end

  return;
end

--
-- Function to update the number of completed artifacts for each race
--
function NigglesArchaeologyUpdateTotals()
  -- Local Variables
  local rarity;
  local numArtifacts;
  local completed;

  -- Check if the option is enabled
  if (NigglesDBC.settings.ProfArchProgress == true) then
    -- Reset the total number of artifacts
    raceInfo[0].numArtifacts[1] = 0;
    raceInfo[0].numArtifacts[2] = 0;

    -- Count the number of rare and common artifacts for each race
    for raceIdx = 1, #raceInfo do
      -- Reset the number of artifacts for the race
      raceInfo[raceIdx].numArtifacts[1] = 0;
      raceInfo[raceIdx].numArtifacts[2] = 0;

      -- Get the total number of artifacts for the race
      numArtifacts = GetNumArtifactsByRace(raceIdx);

      -- Count the number of rare and common artifacts for the race
      for artifactIdx = 1, numArtifacts do
        _, _, rarity, _, _, _, _, completed = GetArtifactInfoByRace(raceIdx,
          artifactIdx);
        -- Check the artifact has actually been completed
        if (completed > 0) then
          if (rarity == 1) then
            raceInfo[raceIdx].numArtifacts[1] =
              raceInfo[raceIdx].numArtifacts[1]+1;
          else
            raceInfo[raceIdx].numArtifacts[2] =
              raceInfo[raceIdx].numArtifacts[2]+1;
          end
        end
      end

      -- Update the total number of artifacts
      raceInfo[0].numArtifacts[1] =
        raceInfo[0].numArtifacts[1]+raceInfo[raceIdx].numArtifacts[1];
      raceInfo[0].numArtifacts[2] =
        raceInfo[0].numArtifacts[2]+raceInfo[raceIdx].numArtifacts[2];
    end

    -- Update the completed page, if it's shown
    if (ArchaeologyFrameCompletedPage:IsShown()) then
      NigglesArchaeologyCompletedUpdate();
    end
  end

  return
end
